package com.micr.b4jping;

import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.objects.collections.List;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.InetAddress;
import java.net.UnknownHostException;
import java.util.ArrayList;
import java.util.logging.Level;
import java.util.logging.Logger;

@BA.Version(0.31F)
@BA.Author("MICR")
@BA.ShortName("B4JPing")

@BA.Events(values = {"ResponseSuccesFull (values As List)", "ResponseError (values As List)"})

public class jPing {

    private BA ba;
    private String eventName;
    private Object callBack;
    List miListaResponseOK = new List();
    List miListaResponseError = new List();
    ArrayList<String> commandList = new ArrayList<String>();
    private int CantPaquetes = 4; //dafault 4 
    private int CantBytes = 32; //dafault 32   
    private int CantTimeout = 4000; //dafault 4000 ms

    private String Host;

    public void Initialize(BA paramBA, Object mCallBack, String EventName) {
        this.ba = paramBA;
        this.eventName = EventName.toLowerCase(BA.cul);
        this.callBack = mCallBack;

        // Inicializar la lista
        miListaResponseOK.Initialize();
        miListaResponseError.Initialize();
        commandList.add("ping");
    }

    //Default es 4
    public void setCantPaquetes(int value) {
        CantPaquetes = value;
        commandList.add("-n");
        commandList.add(CantPaquetes + "");
    }

    //Default es 32
    public void setCantBytes(int value) {
        CantBytes = value;
        commandList.add("-l");
        commandList.add(CantBytes + "");
    }

     //Default es 32
    public void setCantTimeout(int value) {
        CantTimeout = value;
        commandList.add("-w");
        commandList.add(CantTimeout + "");
    }
    
    // method for finding the ping statistics of website
    public void Start() {
        try {
            // creating the sub process, execute system command
            ProcessBuilder build = new ProcessBuilder(commandList);
            Process process = build.start();

            // to read the output
            BufferedReader input = new BufferedReader(new InputStreamReader(process.getInputStream()));
            BufferedReader Error = new BufferedReader(new InputStreamReader(process.getErrorStream()));
            String s = null;

            miListaResponseOK.Clear();
            miListaResponseError.Clear();

            while ((s = input.readLine()) != null) {
                miListaResponseOK.Add(s);
            }

            while ((s = Error.readLine()) != null) {
                miListaResponseError.Add(s);
            }
            if (miListaResponseOK.getSize() > 0) {
                System.out.println("Standard output");
                GenerarEventoResponseOK(miListaResponseOK);
            }
            if (miListaResponseError.getSize() > 0) {
                System.out.println("Error output");
                GenerarEventoResponseError(miListaResponseError);
            }
        } catch (IOException ex) {
            Logger.getLogger(jPing.class.getName()).log(Level.SEVERE, null, ex);
        }

    }

    public void AddHost(String host) {
        commandList.add(host);
        this.Host= host;
    }

    private void GenerarEventoResponseOK(List input) {
        if (ba.subExists(eventName + "_responsesuccesfull")) {
            ba.raiseEventFromUI(callBack, eventName + "_responsesuccesfull", input);
        }
    }

    private void GenerarEventoResponseError(List miListaResponseError) {
        if (ba.subExists(eventName + "_responseerror")) {
            ba.raiseEventFromUI(callBack, eventName + "_responseerror", miListaResponseError);
        }
    }

    public boolean sendPingRequest(int timeOut) {
        boolean result = false;
        try {
            InetAddress geek = InetAddress.getByName(this.Host);
            result = geek.isReachable(timeOut);

        } catch (UnknownHostException ex) {
           anywheresoftware.b4a.BA.LogInfo("Unknown host");  
           anywheresoftware.b4a.BA.Log(ex.getMessage());

        } catch (IOException ex) {
             anywheresoftware.b4a.BA.Log(ex.getMessage());
        }
        return result;
    }

   
}
